config/routes.rb
Rails.application.routes.draw do

  resources :credit_sources
  resources :crop_types
  mount_devise_token_auth_for 'User', at: 'auth'
  get 'report/index'
  get 'report/topography'
  get 'report/smu'
  get 'report/category'
  get 'report/report_list'
  get 'report/farmer_count'
  get 'report/cultivation_cost'
  get 'report/live_stock'
  get 'report/main_yield'
  get 'report/marketing'
  get 'report/comments'
  get 'report/soil_status'
  get 'report/additional_invst_src'
  
  get 'farmers/count'
  get 'users/register'
  get 'users/signin'
  get 'users/template'
  get 'users/index'
  get 'users/actions'
  get 'users/user_roles_template'
  get 'users/user_roles'
  post 'users/create_user_role'
  post 'users/delete_user_role'
 

  post 'offline/sync'

  get "/application.appcache", to: "offline#manifest", :format => :appcache

  get 'roles/ractions'
  get 'roles/role_ractions_template'
  get 'roles/role_ractions'
  get 'roles/role'
  post 'roles/create_role_raction'
  post 'roles/delete_role_raction'

    resources :ractions
  resources :actions
  resources :roles

    root 'socio_demographic_infos#new'
  resources :basic_need_details
  resources :migration_consequences
  resources :labour_migration_details
  resources :migration_negative_consequences
  resources :migration_positive_consequences
  resources :migration_purposes
  resources :fertilizers
  resources :pc_wage_rates
  resources :pc_yield_prices
  resources :intercrop_lists
  resources :crop_lists
  resources :pc_other_expenses
  resources :pc_operation_details
  resources :survey_numbers
  resources :forestry_plants
  resources :horticulture_plants
  resources :livestock_names
  resources :credit_avail_purposes
  resources :suggestion_paramaters
  resources :food_materials
  resources :constraints
  resources :conversation_structures
  resources :particulars
  resources :purposes
  resources :income_sources
  resources :intercrops
  resources :crops
  resources :grampanchayats
  resources :hoblis
  resources :micro_water_sheds
  resources :sub_water_sheds
  resources :taluks
  resources :districts
  resources :castes
  resources :smus
  resources :topographies
  resources :farmers
  resources :horticulture_forestry_plants
  resources :production_costs
  resources :fertilizer_details
  resources :ppc_details
  resources :forestry_cultivations
  resources :forestry_species
  resources :cultivate_horticultures
  resources :plant_counts
  resources :subsidiary_costs
  resources :subsidiary_enterprises
  resources :private_credits
  resources :institutional_credits
  resources :borrowing_statuses
  resources :basic_needs
  resources :labour_availabilities
  resources :watershed_comments
  resources :improvement_suggestions
  resources :household_food_materials
  resources :farming_constraints
  resources :conversation_practices
  resources :watershed_awarenesses
  resources :marketings
  resources :additional_investment_capacities
  resources :family_annual_incomes
  resources :fodder_availabilities
  resources :cropping_intensities
  resources :cropping_paterns
  resources :irrigations
  resources :surveys

  resources :durable_assets
  resources :machines
  resources :livestocks
  resources :livestock_types
  resources :machine_types
  resources :asset_types
  resources :house_types
  resources :houses
  resources :housetypes
  resources :local_organisations
  resources :genders
  resources :occupations
  resources :scaffolds
  resources :educations
  resources :socio_demographic_infos
  resources :villages
  match "*path", to: "welcome#catch_404", via: :all

  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/migration_consequence.rb
class MigrationConsequence < ApplicationRecord
	belongs_to :migration_positive_consequence
	belongs_to :migration_negative_consequence
	belongs_to :farmer


	include Reportable
	def self.farmer_count(type, mws, report)
     @farmer_count = {}
     __data = Migration.frmr(type, mws).group('name', "#{plural(type)}.name").sum(:migration_family_count)
     __data.collect{|k,v| @farmer_count[k[1]] =  (@farmer_count[k[1]].blank? ? 0 : @farmer_count[k[1]]).to_i + v}
    # # self.joins(:farmer => [:village, type.to_sym]).where("villages.micro_water_shed_id" => mws).group("#{plural(type)}.name").count
    @farmer_count
  end
end

app/controllers/migration_consequences_controller.rb
class MigrationConsequencesController < ApplicationController
  before_action :set_migration_consequence, only: [:show, :edit, :update, :destroy]

  # GET /migration_consequences
  # GET /migration_consequences.json
  def index
    @migration_consequences = params[:farmer_id].present? ? MigrationConsequence.where(farmer_id: params[:farmer_id]) : MigrationConsequence.all
    render layout: false
  end

  # GET /migration_consequences/1
  # GET /migration_consequences/1.json
  def show
  end

  # GET /migration_consequences/new
  def new
    @migration_consequence = MigrationConsequence.new
  end

  # GET /migration_consequences/1/edit
  def edit
  end

  # POST /migration_consequences
  # POST /migration_consequences.json
  def create
    @migration_consequence = MigrationConsequence.new(migration_consequence_params)

    respond_to do |format|
      if @migration_consequence.save
        format.html { redirect_to @migration_consequence, notice: 'Migration consequence was successfully created.' }
        format.json { render :show, status: :created, location: @migration_consequence }
      else
        format.html { render :new }
        format.json { render json: @migration_consequence.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /migration_consequences/1
  # PATCH/PUT /migration_consequences/1.json
  def update
    respond_to do |format|
      if @migration_consequence.update(migration_consequence_params)
        format.html { redirect_to @migration_consequence, notice: 'Migration consequence was successfully updated.' }
        format.json { render :show, status: :ok, location: @migration_consequence }
      else
        format.html { render :edit }
        format.json { render json: @migration_consequence.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /migration_consequences/1
  # DELETE /migration_consequences/1.json
  def destroy
    @migration_consequence.destroy
    respond_to do |format|
      format.html { redirect_to migration_consequences_url, notice: 'Migration consequence was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_migration_consequence
      @migration_consequence = MigrationConsequence.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def migration_consequence_params
      params.require(:migration_consequence).permit(:migration_positive_consequence_id, :migration_negative_consequence_id, :farmer_id)
    end
end

app/views/migration_consequences/_form.html.haml
= form_for @migration_consequence do |f|
  - if @migration_consequence.errors.any?
    #error_explanation
      %h2= "#{pluralize(@migration_consequence.errors.count, "error")} prohibited this migration_consequence from being saved:"
      %ul
        - @migration_consequence.errors.full_messages.each do |msg|
          %li= msg

  .field
    = f.label :migration_positive_consequence_id
    = f.number_field :migration_positive_consequence_id
  .field
    = f.label :migration_negative_consequence
    = f.number_field :migration_negative_consequence
  .actions
    = f.submit 'Save'

app/views/migration_consequences/edit.html.haml
%h1 Editing migration_consequence

= render 'form'

= link_to 'Show', @migration_consequence
\|
= link_to 'Back', migration_consequences_path

app/views/migration_consequences/index.html.haml
%h1 Listing migration_consequences

%table
  %thead
    %tr
      %th Migration positive consequence
      %th Migration negative consequence
      %th
      %th
      %th

  %tbody
    - @migration_consequences.each do |migration_consequence|
      %tr
        %td= migration_consequence.migration_positive_consequence_id
        %td= migration_consequence.migration_negative_consequence
        %td= link_to 'Show', migration_consequence
        %td= link_to 'Edit', edit_migration_consequence_path(migration_consequence)
        %td= link_to 'Destroy', migration_consequence, :method => :delete, :data => { :confirm => 'Are you sure?' }

%br

= link_to 'New Migration consequence', new_migration_consequence_path

app/views/migration_consequences/new.html.haml
%h1 New migration_consequence

= render 'form'

= link_to 'Back', migration_consequences_path

app/views/migration_consequences/show.html.haml
%p#notice= notice

%p
  %b Migration positive consequence:
  = @migration_consequence.migration_positive_consequence_id
%p
  %b Migration negative consequence:
  = @migration_consequence.migration_negative_consequence

= link_to 'Edit', edit_migration_consequence_path(@migration_consequence)
\|
= link_to 'Back', migration_consequences_path